## So you'd like to contribute to OACC&hellip;

---

Thanks - that's awesome! After all, the OACC framework is an open-source project that welcomes and encourages contributions from community members like you.

To make this process as effortless as possible, please take a minute and read this guide before contributing.

Thanks again - you rock!

### Reporting Bugs
- Report bugs as issues on GitHub _- after first searching for duplicates -_ and include detailed steps for reproduction (version, DBMS, code)
- For questions about possible bugs or documentation-related issues, please ask on the [OACC mailing list](https://groups.google.com/forum/#!forum/oacc-users)

### Contributing Code
- For API changes, new features, elaborate enhancements or radical refactorings, please discuss on the [OACC mailing list](https://groups.google.com/forum/#!forum/oacc-users) first
- When in doubt or for any questions, please ask on the [OACC mailing list](https://groups.google.com/forum/#!forum/oacc-users) before investing a lot of your time
- You will need to fill out the [Acciente Contributor's License Agreement (CLA)](https://github.com/acciente/acciente-cla) before we can accept and merge your code contribution(s)
- In general, please make sure to:
    + add a test for any new feature/enhancement
    + run the test suite for any changes
    + apply the boy-scout rule: _"Leave the code cleaner than you found it"_
    + make an effort to adhere to the existing coding style (ask on the [OACC mailing list](https://groups.google.com/forum/#!forum/oacc-users) if you can't determine it)
    + update the existing documentation (javadocs &amp; comments) if you change the API (did you discuss this on the mailing list first?)
    + include the Acciente copyright notice at the top of new files
    + properly scope your commits, and include meaningful commit messages in a format that answers why a change was made and/or how it addressed an issue

### Writing Documentation
- To improve the existing documentation or to create new guides or tutorials, please submit your documentations to the [OACC mailing list](https://groups.google.com/forum/#!forum/oacc-users)
- Be sure to share your links to any external tutorials, articles, blog posts, best practices, etc. on the [OACC mailing list](https://groups.google.com/forum/#!forum/oacc-users)